import {inject, Inject, Injectable} from "@angular/core";
import { HttpClient } from '@angular/common/http';
import { HttpDataSourceOptionsBuilder } from "./HttpDataSourceBuilder";
import { SingleDataSourceOptionsBuilder } from "./SingleObjectDataSourceBuilder";
import { ListDataSourceOptionsBuilder } from "./ListDataSourceBuilder";


@Injectable({
  providedIn: 'root'
})
export class HttpDataSourceService {
  protected http: HttpClient = inject(HttpClient);

  builder<TQuery, TModel>() {
    return new HttpDataSourceOptionsBuilder<TQuery, TModel>(this.http);
  }

  singleBuilder<TQuery, TModel>() {
    return new SingleDataSourceOptionsBuilder<TQuery, TModel>(this.http);
  }

  listBuilder<TQuery, TModel>() {
    return new ListDataSourceOptionsBuilder<TQuery, TModel>(this.http);
  }
}
